/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;

import org.eclipse.emf.ecore.EObject;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Test Resource</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestResource#getFoo <em>Foo</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestResource#getBar <em>Bar</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestResource()
 * @model
 * @generated
 */
@ProviderType
public interface TestResource extends EObject {
	/**
	 * Returns the value of the '<em><b>Foo</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Foo</em>' attribute.
	 * @see #setFoo(String)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestResource_Foo()
	 * @model
	 * @generated
	 */
	String getFoo();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestResource#getFoo <em>Foo</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Foo</em>' attribute.
	 * @see #getFoo()
	 * @generated
	 */
	void setFoo(String value);

	/**
	 * Returns the value of the '<em><b>Bar</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bar</em>' attribute.
	 * @see #setBar(String)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestResource_Bar()
	 * @model
	 * @generated
	 */
	String getBar();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestResource#getBar <em>Bar</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bar</em>' attribute.
	 * @see #getBar()
	 * @generated
	 */
	void setBar(String value);

} // TestResource
